#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "MsgWins.h"
#include "MsgInWin.h"
#include "NoteWins.h"
#include "SaveDlg.h"
#include "RemailerDlgs.h"
#include "SmtpDlgs.h"
#include "QSver.h"
#include "Mixmaster.h"
#include "MixDlgs.h"
#include "DelGrpsDlg.h"
#include "MailboxWins.h"
#include "PickBoxDlgs.h"
#include "addressdlgs.h"
#include "helpdlgs.h"
#include "UseLibDlg.h"
#include "FirstDocsDlgs.h"
#include "InfoTestManDlgs.h"
#include "NymMail.h"
#include "pgpfiles.h"
#include "pool.h"
#include "view.h"
// pgp stuff
#include "pgpmail.h"
#include "PGPpassEx.h"
#include "PGPrecipDlgs.h"

const bool update = true;
const AnsiString Drafts = "Drafts";
const AnsiString MailListHdr = "Mailing-List: ";
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "TextWins"
#pragma resource "*.dfm"
TMessageWin *MessageWin;
#define PAUSEONMAILLIST 200
//---------------------------------------------------------------------------
bool __fastcall OpenMessage(AnsiString &Mailbox, AnsiString &IndexStr)
{
   if (Mailbox.IsEmpty() || IndexStr.IsEmpty()) return false;
   AnsiString DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   TStringList *msg = new TStringList();
   GetAppData(msg,DataKey);
   MessageWin = new TMessageWin(msg,Mailbox,IndexStr,Application->MainForm);
   delete msg;
   return true;
}
//---------------------------------------------------------------------------
TMessageWin* __fastcall PutMessageOnDesktop(TForm* Owner, TStrings *msg)
{
   MessageWin = new TMessageWin(msg,"","",(TComponent*)Owner);
   MessageWin->Editor->WordWrap = false;
   MessageWin->Editor->Modified = true;
   MessageWin->FinalFormat = true;
   return MessageWin;
}
//---------------------------------------------------------------------------
TMessageWin* __fastcall PutNymMessageOnDesktop(TForm* Owner, TStrings *msg)
{
   return PutMessageOnDesktop(Owner,msg);
}
//---------------------------------------------------------------------------
char __fastcall GetMsgStatus(AnsiString &DataKey)
{
   if (DataKey.Pos(UserMailboxes)!=1) return '\0';

   AnsiString Mailbox,IndexStr;
   Mailbox = GetParam(1,DataKey,PS.c_str());
   IndexStr = GetParam(2,DataKey,PS.c_str());
   if (IndexStr==HeaderText) return GetParam(3,IndexStr," ").SubString(1,1)[1];

   if (!IsNewStyle(DataKey)) return 'S';  // only outgoing is old style
   char status=IndexStr.SubString(24,1)[1];
   if (status=='i') return ' ';
   if (status=='o') return 'S';
   return status;
}
//---------------------------------------------------------------------------
bool __fastcall SetMsgStatus(AnsiString &DataKey, char status)
{
   if (DataKey.Pos(UserMailboxes)!=1) return false;

   AnsiString Mailbox,IndexStr;
   Mailbox = GetParam(1,DataKey,PS.c_str());
   IndexStr= GetParam(2,DataKey,PS.c_str());
   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (IndexStr.Length()>=24)
   {
      IndexStr[24] = status;
      RenameAppItem(DataKey,IndexStr);
      if (box) box->MailGrid->RefreshIndex();
      DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall IsNewStyle(AnsiString &DataKey)
{
   AnsiString idxstr = GetParam(2,DataKey,PS.c_str());
   return idxstr.SubString(23,1)==InCode || idxstr.SubString(23,1)==OutCode;
}
//---------------------------------------------------------------------------
bool __fastcall IsIncoming(AnsiString &DataKey)
{
   AnsiString idxstr = GetParam(2,DataKey,PS.c_str());
   return IsNewStyle(DataKey) && idxstr.SubString(23,1)==InCode;
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   return cut;
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::TMessageWin(TComponent* Owner) : TTextWin(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::TMessageWin(TStrings* Message, AnsiString mailbox,
   AnsiString indexstr, TComponent* Owner) : TTextWin(Owner)
{
   Font->Name = GetAppIni(EdFontName,"Courier New"); // fror wrap to window
   Font->Size = GetAppIni(EdFontSize,"").ToIntDef(10);
   // fix button font affected from above assignments
   OkBtn->Font->Name = "MS Sans Serif";
   OkBtn->Font->Size = 8;
   Mailbox = mailbox;
   IndexStr = indexstr;
   if (!Mailbox.IsEmpty()) DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   Type = DataKey.IsEmpty() ? tNewMessage : tMessage;
   Headers = new THeaderManager(Editor->Lines);
   Editor->Lines->Text = Message->Text;
   ClearText = 0;
   QSPoolHeaderToClearText(ClearText,Editor->Lines);
   PgpHeaderToButtons(Editor->Lines);
   PGPencBtn->Hint = !HasPgp() ?
      "PGP conventional encrypt|PGP conventional encrypt this message on queueing/sending" :
      "PGP encrypt|PGP encrypt this message on queueing/sending";
   if (!HasPgp()) SetNoPgp();

   if (!HasMix()) SetNoMixmaster();
   MessageSent = false;
   FinalFormat = false;
   SetMessage();
   SetTrashBtnPos();
   UseLibBtn->Visible = FileExists(ChangeFileExt(AppExeName,".dsk"));
   if (Type==tNewMessage || Type==tNewArticle)
      TrashBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetTrashBtnPos()
{
   MsgHelpBtn->Left = Width-(MsgHelpBtn->Width+10);
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::~TMessageWin()
{
   delete Headers;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified)
   {
      if (ModalResult==mrOk) Save(); else
      if (!CheckSave())
      {
         CanClose = false;
         return;
      }
   }
   if (MDIChildCount==0) SetParentButtons(false);
   ShowCurXY(false);
   closing = true;

   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (box) SetRedraw(box->MailGrid,0);
   if (!MessageSent && !InReplyTo.IsEmpty()) SetMsgStatus(InReplyTo,' ');
   if (box) SetRedraw(box->MailGrid,1);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetNoMixmaster()
{
   PGPencBtn->Visible = false;
   PGPsigBtn->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetNoPgp()
{
   PGPsigBtn->Visible = false;
   for (int i=0; i<Panel1->ControlCount; i++)
      if (Panel1->Controls[i]->Left > PGPencBtn->Left)
          Panel1->Controls[i]->Left -= PGPsigBtn->Width;
//Bevel99->Visible = false;
//Bevel99->Left -= 29;
}
//---------------------------------------------------------------------------
/*bool __fastcall TMessageWin::UpdateStatsOnSend()
{
   return Application->MainForm->Perform(WM_UPDATECHECKED,0,NULL)>0;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::RegisterStatsUpdated()
{
   Application->MainForm->Perform(WM_UPDATECHECKED,1,NULL);
}*/
//---------------------------------------------------------------------------
void __fastcall TMessageWin::NewMessage()
{
   bool locked=LockWindowUpdate(Handle);
   GetAppData(Editor->Lines,DefaultMessage); SetCursor();
   QSPoolHeaderToClearText(ClearText,Editor->Lines);
   PgpHeaderToButtons(Editor->Lines);
   Editor->Modified = false;
   Caption = newMessage;
   SetCursor();
   Type = tNewMessage;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::NewArticle()
{
   bool locked=LockWindowUpdate(Handle);
   GetAppData(Editor->Lines,DefaultArticle); SetCursor();
   QSPoolHeaderToClearText(ClearText,Editor->Lines);
   PgpHeaderToButtons(Editor->Lines);
   Editor->Modified = false;
   Caption = newArticle;
   SetCursor();
   Type = tNewArticle;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetCursor()
{
   Editor->SelStart = 0;
   TStrings *msg = Editor->Lines;
   int pos,eoh = msg->Text.Pos("\r\n\r\n");
   if (eoh==0) eoh = msg->Text.Length();
   if ((pos=msg->Text.Pos(": \r\n"))>0 && pos<eoh)
      Editor->SelStart = pos+1;
   else
   if (!pos && (pos=msg->Text.Pos(": ;"))>0 && pos<eoh)
      Editor->SelStart = pos+1;
   else
   {
      Editor->SelStart = eoh;
      if (eoh < msg->Text.Length())
         Editor->SelStart = Editor->SelStart+4;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveDefMessage()
{
   AnsiString pgp,s;
   // make sure first null line is actually null and not space(s)
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      s = Editor->Lines->Strings[i];
      if (!s.IsEmpty() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
   // remove trailing null lines
   while (Editor->Lines->Count && Editor->Lines->Strings[Editor->Lines->Count-1].Trim().IsEmpty())
      Editor->Lines->Delete(Editor->Lines->Count-1);
   // save message
   ButtonsToPgpHeader(Editor->Lines);
   if (PutAppData(DefaultMessage,Editor->Lines)==TOOL_OK)
   {
      Editor->Clear(); Sleep(SleepTime);
      NewMessage();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveDefArticle()
{
   AnsiString pgp,s;
   // make sure first null line is actually null and not space(s)
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      s = Editor->Lines->Strings[i];
      if (!s.IsEmpty() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
   // remove trailing null lines
   while (Editor->Lines->Count && Editor->Lines->Strings[Editor->Lines->Count-1].Trim().IsEmpty())
      Editor->Lines->Delete(Editor->Lines->Count-1);
   // save message
   ButtonsToPgpHeader(Editor->Lines);
   if (PutAppData(DefaultArticle,Editor->Lines)==TOOL_OK)
   {
      Editor->Clear(); Sleep(SleepTime);
      NewArticle();
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Save()
{
   if (Type==tNewMessage||Type==tNewArticle) return SaveAs();

   AnsiString cap = Caption;
   switch (Type)
   {
      case tTemplate: Caption = "Saving template..."; break;
      case tDraft: Caption = "Saving draft..."; break;
      default:
         Caption = "Saving draft...";
   }
   AppProcessMessages(); Sleep(400);
   Caption = cap;

   TStringList *lines = new TStringList();
   GetUnWrappedText(lines);
   ButtonsToPgpHeader(lines);
   PutAppData(DataKey,lines);
   Editor->Modified = false;
   delete lines;
   ShowStatus(Caption+" ... saved");
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAs()
{
   AnsiString path = GetSaveMessagePath(UserMessages,Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      Caption = "Saving draft...";
      AppProcessMessages(); Sleep(400);

      TStringList *lines = new TStringList();
      GetUnWrappedText(lines);
      ButtonsToPgpHeader(lines);
      PutAppData(DataKey,lines);
      Editor->Modified = false;

      Caption = GetParam(0,UserMessages+": "+GetParam(1,DataKey,PS.c_str()));
      ShowStatus(Caption+" ... saved");
      Type = tDraft;
      delete lines;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAsTemplate()
{
   AnsiString path,pgphdr;
   path = GetSaveMessagePath(UserTemplates+"only",Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      Caption = "Saving template...";
      AppProcessMessages(); Sleep(400);

      TStringList *lines = new TStringList();
      GetUnWrappedText(lines);
      ButtonsToPgpHeader(lines);
      PutAppData(DataKey,lines);
      Editor->Modified = false;

      Caption = GetParam(0,DataKey,PS.c_str())+": "+GetParam(1,DataKey,PS.c_str());
      ShowStatus(Caption+" ... saved");
      Type = tTemplate;
      delete lines;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      switch (MsgBox("Your message is modified. Changes will be lost!\n\nQueue it now?",
                 "Queue Message",MB_YESNOCANCEL))
      {
         case mrYes:
            if (!Queue(true)) return false;
            // fall through
         case mrNo:
            Editor->Modified = false;
            //Close();
            break;
         case mrCancel:
            ok = false;
            break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckValid()
{
   AnsiString fcc;
   if (!ValidMail())
   {
      // missing header info that is required
      MsgBox(
         AnsiString("Valid entries are required for 'Host', 'From'\n")+
         AnsiString("and 'To' headers."),
        "Message Error",
         MB_OK
      );
      return false;
   }
   if (Headers->Has("Chain: ") && !RegKeyExists(MixKey))
   {
      MsgBox(
         AnsiString("Message contains a 'Chain:' header, but\n")+
         AnsiString("Mixmaster is not installed!\n\n")+
         AnsiString("Please remove the 'Chain:' header."),
        "Message Error",
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMessageWin::Name()
{
   if (Type==tDraft||Type==tTemplate) return GetParam(1,DataKey,PS.c_str()); else
   if (Type==tNewMessage) return newMessage; else
   if (Type==tNewArticle) return newArticle; else
   return ""; // tMessage,tArticle
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMessageWin::Section()
{
//   AnsiString section;
//   if (Caption!=newMessage && Caption!=newArticle)
//      section = Caption.SubString(1,Caption.Pos(":")-1);
//   return section;
   return Mailbox;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetWinCaption()
{
   AnsiString cap=IndexStr+" ",fs=FieldSep,oc=OutCode;
   if (cap.Pos(InCode)>0 || cap.Pos(OutCode)>0)
   {
      for (int i=1; i<=cap.Length(); i++)
         if (cap[i]==fs[1] || cap[i]==oc[1]) cap[i]=' ';
if (!ISDESIGNING) cap = cap.SubString(1,19)+" "+cap.SubString(21,256);
      cap = cap.Trim();
      while (cap.Length() && cap[cap.Length()]!=' ')
         cap.SetLength(cap.Length()-1);
   }
   Caption = Mailbox+": "+cap;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetMessage(bool setcursor)
{
   Editor->OnSelectionChange = NULL;
   AnsiString cap=GetToken(2,DataKey,PS.c_str());
   if (Mailbox.IsEmpty() && cap.Trim().IsEmpty())
      Caption = Headers->Get("Newsgroups: ").IsEmpty() ? newMessage:newArticle;
   else
   if (Type==tMessage || Type==tArticle) SetWinCaption();

   if (setcursor)
   {
      Editor->SelStart = 0;
      if (Editor->Lines->Count && Editor->Lines->Strings[0].SubString(1,1)!="#")
         SetCursor();
   }
   Editor->OnSelectionChange = EditorSelectionChange;
//   SaveMessageBtn->Enabled = false;
   Editor->Modified = false;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckMailQueue()
{
   bool check=false;
   TStringList *tmp = new TStringList();
   if (AppDataExists(MailQueue,tmp))
   {
      AnsiString S(tmp->Count>1?"s ":" "),IS(S==" "?"is":"are"),count(tmp->Count);
      int ret=MsgBoxHwnd(Handle,
         AnsiString("There "+IS+" "+count+" message"+S+"in the Mail Queue.\n\n")+
         AnsiString("Take a look, now?"),"Queued Mail",
         MB_YESNOCANCEL
      );
      switch (ret)
      {
         case IDYES: Application->MainForm->Perform(WM_OPENQUEUE,0,NULL);
         case IDCANCEL:
            check=true;
            break;
      }
   }
   delete tmp;
   return check;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckProblemsQueue()
{
   bool check=false;
   TStringList *tmp = new TStringList();
   if (AppDataExists(ProblemQueue,tmp))
   {
      AnsiString S(tmp->Count>1?"s ":" "),IS(S==" "?"is":"are"),count(tmp->Count);
      int ret=MsgBoxHwnd(Handle,
         AnsiString("There "+IS+" "+count+" message"+S+"in the PROBLEM Queue.\n\n")+
         AnsiString("Take a look, now?"),"Previous Problems",
         MB_YESNOCANCEL
      );
      switch (ret)
      {
         case IDYES: Application->MainForm->Perform(WM_OPENPROBLEMS,0,NULL);
         case IDCANCEL:
            check=true;
            break;
      }
   }
   delete tmp;
   return check;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CheckWhiteEOH()
{
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString s = Editor->Lines->Strings[i];
      if (s.IsEmpty()) break;
      if (s.Length() && s.Trim().IsEmpty()) // must test and replace
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckOver80Chars()
{
   bool ok = true;
   TStringList *hold = new TStringList();
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString s = Editor->Lines->Strings[i]; if (s.IsEmpty()) break;
      if (s.Length()<=80) { hold->Add(s); continue; }
      Editor->SelStart = hold->Text.Length();
      Editor->Perform(EM_SCROLLCARET,0,0);
      Application->ProcessMessages();
      MsgBox(
         AnsiString("  You have a header that's too long. Mixmaster allows only 80  \n")+
         AnsiString("  characters. You can probably break the header and continue it  \n")+
         AnsiString("  on the next line. I'll placed the cursor at the beginning of the\n")+
         AnsiString("  problem header. When breaking the header, make sure each  \n")+
         AnsiString("  continued line is indented with a space or a tab. \n")+
         AnsiString("\n\n"),
        "Header Length Problem",
         MB_OK
      );
      ok = false;
      break;
   }
   delete hold;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CheckReferences()
{
   int pos;
   if (!Headers->Has("Chain: ")) return;

   AnsiString refs = Headers->GetReferences(Editor->Lines);
   while (references.Length()+refs.Length() > 80)
   {
      if ((pos=refs.Pos(">"))==0) break;
      refs = refs.SubString(pos+2,1024);
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckNewsgroups()
{
   int pos;
   bool ok = true;
   if (!Headers->Has("Chain: ")) return ok;

   AnsiString grps = Headers->GetNewsgroups();
   if (newsgroups.Length()+grps.Length() > 80)
   {
      if ((ok=MassageNewsgroups(grps,this))==true)
      {
         pos=0; while(++pos<grps.Length()-1)
            if (grps[pos]==',') grps.Insert("\r\n ",pos+1);
         Editor->Lines->Insert(Headers->Delete(newsgroups),newsgroups+grps);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
int  __fastcall TMessageWin::SendWordWrap()
{
  int wrap=0;
  bool set=false;
  for (int l=0; l<Editor->Lines->Count; l++)
  {
     AnsiString s=Editor->Lines->Strings[l];
     if (s.Pos("-----BEGIN PGP ")==1) set = true;
     if (set || s.IsEmpty()) break;
  }
  if (set) return wrap;

  if (GetAppIni(SendWrapWin,"")=="1")
     wrap = Editor->ClientWidth/Canvas->TextWidth("X"); else
  if (GetAppIni(SendWrapChars,"")=="1")
     wrap = GetAppIni(SendWrapCharsCount,"").ToIntDef(68);
  return wrap;
}
//---------------------------------------------------------------------------
bool __fastcall HasBadChainHeader(HWND Handle, TStrings *msg)
{
   bool bad=false;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString hdr = msg->Strings[i].LowerCase();
      if (hdr.IsEmpty()) break;
      if (hdr.Pos("chain")==1 && hdr.Pos("chain: ")!=1)
      {
         bad = true;
         MsgBoxHwnd(Handle,
            s("You have a malformed 'Chain:' header. It appears you\n")+
            s("have forgotten, or misplaced, the colon immediately after\n")+
            s("the word 'Chain'. The proper format is:\n\n")+
            s("'Chain: '"),
            s("Chain Header Error"),
            MB_OK
         );
         break;
      }
   }
   return bad;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::ValidMail()
{
   AnsiString hst,frm,rcp;
   hst = Headers->GetDat("Host: ");
   frm = Headers->GetDat("From: ");
   rcp = Headers->GetDat("To: ");
   return !(hst==""||frm==""||rcp==""||frm.Pos("@")<2||rcp.Pos("@")<2);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::TapQueues()
{
   Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
   Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::IsPgpEncrypt()
{
   if (PGPencBtn->Down) return true;
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::IsPgpMessage()
{
   if (PGPencBtn->Down || PGPsigBtn->Down || HasHeader(PgpHdr)) return true;
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::IsNymMessage()
{
   return Headers->Has(NymHdr);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HandleNym()
{
   int idx; AnsiString nym,nymserver,nymaddrs;
   THeaderManager *hm = new THeaderManager(Editor->Lines);
   TStringList *nyms = new TStringList();
   GetAppData(nyms,NymProfilesKey);
   if ((idx=nyms->IndexOf(hm->GetDat(NymHdr)))<0)
   {
      MsgBoxHwnd(Handle,"The nym you specified doesn't exist!","Nym Error",MB_OK);
      delete nyms;
      delete hm;
      return false;
   }

   bool ok = true;
   // go on to format the message for nym
   AnsiString nymid,serid,hdr;
   nymaddrs = nyms->Strings[idx];
   nym = GetToken(0,nymaddrs,"@");
   nymserver = "send@"+GetToken(1,nymaddrs,"@");
   // get nym's pgp keyid
   TStringList *prof = new TStringList();
   GetAppData(prof,NymProfilesKey+PS+nymaddrs);
   for (int i=0; i<prof->Count; i++)
   {
      if (prof->Strings[i].Pos("PgpKey: ")==1)
      {
         nymid = prof->Strings[i].SubString(9,10);
         break;
      }
   }
   delete prof;
   delete nyms;
   // get nymserver's pgp keyid
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *remkeys = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);
   while (key->copykeyfrom(remkeys,REWIND))
   {
      if (key->getuserids().Pos(nymserver)>0)
      {
         serid = "0x"+key->idtext8;
         break;
      }
   }
   if (serid.IsEmpty())
   {
      MsgBoxHwnd(Handle,"I can't locate a PGP key for '"+nymserver+"'.","PGP Error",MB_OK);
      ok = false;
   }
   delete remkeys;
   delete key;
   // got enough info now, process the message
   if (ok)
   {
      TStringList *msg = new TStringList();
      GetUnWrappedText(msg);
      WrapMessage(msg,SendWordWrap());
      MassageNewsgroupsAndReferencesAndSubject(msg);
      Editor->Clear();

      AppProcessMessages(); Sleep(100);
      SetRedraw(this,0);

      hm->Delete("Nym: ",msg);
      TStringList *hdrs = new TStringList();
      TStringList *ndrs = new TStringList();
      // get nym headers
      ndrs->Add("From: "+nym);
      if ((hdr=hm->GetDel("To: "))!="") ndrs->Add(hdr);
      if ((hdr=hm->GetDel("Cc: "))!="") ndrs->Add(hdr);
      if ((hdr=hm->GetDel("Bcc: "))!="") ndrs->Add(hdr);
      // get message headers
      while ((hdr=hm->GetDel(PgpHdr))!="") hdrs->Add(hdr);
      hdrs->Add(s(PgpHdr)+"sign="+nymid+"; encrypt="+serid);
      if ((hdr=hm->GetDel("Fcc: "))!="") hdrs->Add(hdr);
      if ((hdr=hm->GetDel("Host: "))!="") hdrs->Add(hdr);
      if ((hdr=hm->GetDel("From: "))!="") hdrs->Add(hdr);
      if ((hdr=hm->GetDel("Chain: "))!="") hdrs->Add(hdr);
      hdrs->Add("To: "+nymserver);
      // back to adding nym headers
      while ((hdr=hm->PopHeader())!="") ndrs->Add(hdr);
      if (msg->Count) msg->Delete(0);
      // assemble message
      Editor->Lines->Clear();
      Editor->Lines->AddStrings(hdrs);
      Editor->Lines->Add("");
      Editor->Lines->AddStrings(ndrs);
      Editor->Lines->Add("");
      Editor->Lines->AddStrings(msg);
      // finish up
      Editor->SelStart = 0;
      AppProcessMessages();
      SetRedraw(this,1);
      delete msg;
   }
   delete hm;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HasBadAttachment(TStrings *msg)
{
   int pos; AnsiString hdr,file;
   THeaderManager *hm = new THeaderManager(msg);
   hdr = hm->Get("Attachment: ");
   delete hm;

   if (hdr.IsEmpty()) return false;
   AnsiString attach = hdr.SubString(13,512);
   if (attach.IsEmpty())
   {
      MsgBoxHwnd(Handle,
         "You have an 'Attachment: ' header, but no filenames given!",
         "Attachment Error",
          MB_OK);
      return true;
   }
   while((pos=attach.Pos("\r"))>0) attach.Delete(pos,1);
   while((pos=attach.Pos("\n"))>0) attach.Delete(pos,1);
   pos=0; while((file=GetToken(pos,attach,","))!="")
   {
      if (!FileExists(file))
      {
         MsgBoxHwnd(Handle,
            "The file you wish to attach '"+file+"' doesn't exist!",
            "Attachment Error",
             MB_OK);
         return true;
      }
      pos++;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Queue(bool AndSend)
{
 /*if (InfoDlgsValues->Values[TestMsgManners]!="1")
   {
      THeaderManager *hm = new THeaderManager(Editor->Lines);
      AnsiString sub = " "+hm->GetDat("Subject: ").LowerCase()+" ";
      if ((sub.Pos(" test ")>0 || sub.Pos(" testing ")>0) &&
          hm->GetDat("Newsgroups: ").LowerCase().Pos("alt.privacy.anon-server")>0)
      {
         if (ExplainTestMessageManners(AppMainForm)==mrCancel)
            return false;
      }
   }*/
   CheckWhiteEOH();
   TStrings *Lines = Editor->Lines;
   if (HasBadChainHeader(Handle,Lines) || HasBadAttachment(Lines)) return false;
   if ((Limit80Chars && Headers->Has("Chain: ")) &&
      (!CheckOver80Chars() || !CheckNewsgroups())) return false;

   if (CheckValid())
   {
      pgpstart:
      if (HasPgp()) while(IsPgpMessage()) if (!HandlePGP()) return false;
      if (IsPgpEncrypt() && !HandleCPGP()) return false;
      if (HasNyms() && IsNymMessage() && !HandleNym()) return false;
      if (HasHeader(PgpHdr)) goto pgpstart;

      Editor->SelStart = 0; AppProcessMessages(); Sleep(100);
      if (Headers->Has("Chain: ")) SetQueueHasChainMail(true);
      int SendWrap = FinalFormat?0:SendWordWrap();
      if (QueueMessage(SendWrap,ClearText,AndSend))
      {
         if (!AndSend) Close(); // else closed by mainmdi
         return true;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::QueueMessage(int WordWrap, int ClearText, bool Sending)
{
   if (HasBadChainHeader(Handle,Editor->Lines)) return false;
   cap = Caption; Caption = "Queueing...";
   TStringList *lines = new TStringList();
   GetUnWrappedText(lines);
   // remove any previous error messages from top of message
   while (lines->Count && lines->Strings[0].Pos("#")==1) lines->Delete(0);
   // add wordwrap header
   lines->Insert(0,WordWrapHeader+AnsiString(WordWrap));
   // add cleartext header if cleartext is available
   QSPoolClearTextToHeader(lines,ClearText);
   AnsiString cap = Caption; Caption = "Queueing...";
   // trim message, add 1 null line
   TrimNullsAfter(lines); lines->Add("");
   // queue message
   PutAppData(MailQueue+PS+Headers->IndexString(lines),lines);
   if (!Sending) Sleep(200);
   Editor->Modified = false;
   Caption = cap;
   delete lines;
   TapQueues();
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Send()
{
   TStrings *Lines = Editor->Lines;
   AnsiString chain=Headers->GetDat("Chain: ");
   if (HasBadChainHeader(Handle,Lines) || HasBadAttachment(Lines) ||
       CheckProblemsQueue()) return false;

   // bring up
   if (!chain.IsEmpty())
   {
      if (!FileExists(mlisttxt) || !FileExists(mringtxt))
      {
         if (GetFirstRemailerDocs(AppMainForm)) GetRemailerStats(AppMainForm,true);
         return false;
      }
   }
   if (Queue(true)) // true=sending
   {
      // Send a message to the mainform letting it take
      // control--close this window, set a timer, wait, open smtpdlg
      PostMessage(AppMainForm->Handle,WM_SENDMAIL,0,(LPARAM)this);
      MessageSent = true;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::QueueBtnClick(TObject *Sender)
{
   AnsiString chain=Headers->GetDat("Chain: ");
   // look for new install--ie no remailer docs
   if (!chain.IsEmpty())
   {
      if (!FileExists(mlisttxt) || !FileExists(mringtxt))
      {
         if (GetFirstRemailerDocs(AppMainForm)) GetRemailerStats(AppMainForm,true);
         return;
      }
   }
   Queue(false);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnClick(TObject *Sender)
{
   Send();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormResize(TObject *Sender)
{
   SetEditRect();
   SetTrashBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormShow(TObject *Sender)
{
   //PGPnowBtn->Enabled = PGPsigBtn->Down || PGPencBtn->Down;
   FormResize(NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HasHeader(AnsiString &Header)
{
   bool ok = false;
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString line = Editor->Lines->Strings[i].Trim();
      if (line.Pos(Header)==1) ok = true;
      if (ok||line.IsEmpty()) break;
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::MassageNewsgroupsAndReferencesAndSubject(TStrings *Message)
{  // This procedure is required by HandlePGP and HandleCPGP after saving the original
   // message and before doing actual encryption
   int nidx,fidx,aidx;
   AnsiString ngrps,fgrps,arefs;
   THeaderManager *hm = new THeaderManager(Message);
   // followup-to header
   fgrps = hm->GetFollowupTo();
   fidx = hm->Delete("Followup-To: ");
   if (!fgrps.IsEmpty() && fidx>=0) Message->Insert(fidx,"Followup-To: "+fgrps);
   // newsgroups header
   ngrps = hm->GetNewsgroups();
   nidx = hm->Delete("Newsgroups: ");
   if (!ngrps.IsEmpty() && nidx>=0) Message->Insert(nidx,"Newsgroups: "+ngrps);
   // references header
   arefs = hm->GetReferences();
   aidx = hm->Delete("References: ");
   if (!arefs.IsEmpty() && aidx>=0) Message->Insert(aidx,"References: "+arefs);
   // subject header
   AnsiString sub;
   TStringList *subject = new TStringList();
   subject->Text = hm->GetDat("Subject: ");
   if (subject->Count>1)
   {
      sub = subject->Strings[0].Trim();
      for (int i=1; i<subject->Count; i++)
         sub += " "+subject->Strings[i].Trim();
      int pos = hm->Delete("Subject: ");
      if (pos>=0) Message->Insert(pos,"Subject: "+sub);
      else
      {
         pos = hm->IndexOf("To: ");
         Message->Insert(pos,"Subject: "+sub);
      }
   }
   delete subject;
   delete hm;
}
//---------------------------------------------------------------------------
// PGP stuff
//---------------------------------------------------------------------------
TStringList* __fastcall TMessageWin::CopyMessage(TStrings *Message)
{
   TStringList *org = new TStringList();
   org->Text = Message->Text;
   return org;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HandlePGP()
{
   bool ok=false;
   try
   {
      TStringList *lines = new TStringList();
      THeaderManager *hm = new THeaderManager(lines);
      GetUnWrappedText(lines);
      if (HasHeader("Fcc: ") && !ClearText)
      {
         ClearText = QSPoolNext();
         ButtonsToPgpHeader(lines);
         QSPoolAdd(CopyMessage(lines),s(ClearText));
         PgpHeaderToButtons(lines);
      }
      // massage required here because of encryption of headers
      MassageNewsgroupsAndReferencesAndSubject(lines);
      bool encrypt,sign;
      AnsiString hdrdat;
      if (PGPsigBtn->Down || PGPencBtn->Down)
      {
         sign = PGPsigBtn->Down;
         encrypt = PGPencBtn->Down;
         if (encrypt) hdrdat = "encrypt";
         if (sign) hdrdat += hdrdat.Length()?"; sign":"sign";
         if (sign||encrypt) lines->Insert(0,PgpButtonsHdr+hdrdat);
      }
      else
      {
         hdrdat = hm->GetDat(PgpHdr);
         if (!hdrdat.IsEmpty())
         {
            encrypt = hdrdat.Pos("encrypt")>0;
            sign = hdrdat.Pos("sign")>0;
         }
      }

      TStringList *msg = new TStringList();
      if (!FinalFormat) WrapMessage(lines,GetAppIni(SendWrapCharsCount,"").ToIntDef(68));
      if (encrypt && sign) msg->SetText(PgpEncryptSignMessage(lines->Text.c_str())); else
      if (encrypt) msg->SetText(PgpEncryptMessage(lines->Text.c_str())); else
      if (sign) msg->SetText(PgpSignMessage(lines->Text.c_str()));
      if (msg->Count)
      {
         Editor->Clear();
         AppProcessMessages();

         SetRedraw(this,0);
         FinalFormat = true;
         Editor->WordWrap = false;

         if (hm->Has(PgpHdr,msg)) hm->Delete(PgpHdr); else
         if (hm->Has(PgpButtonsHdr))
         {
            hm->Delete(PgpButtonsHdr);
            PGPencBtn->Down = false;
            PGPsigBtn->Down = false;
         }

         Editor->Lines->Text = msg->Text; Editor->SelStart = 0;

         PopUndoPgpItem->Enabled = true;
         PopDoPgpItem->Enabled = false;
         AppProcessMessages(); Sleep(100);
         SetRedraw(this,1);

         AppProcessMessages(); Sleep(200);
         ok = true;
      }
      delete msg;
      delete hm;
      delete lines;
   }
   catch (...)
   {
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HandleCPGP()
{
   AnsiString passphrase;
   if (!PGPencBtn->Down || !PGPGETConventionalPassphrase(this,passphrase))
      return false;

   int mrResult=mrOk;
   // transfer unwrapped message to msg stringlist
   TStringList *msg = new TStringList();
   bool locked,ww=Editor->WordWrap;
   locked = LockWindowUpdate(Handle);
   if (ww) Editor->WordWrap = false;
   msg->Text = Editor->Lines->Text;
   if (ww) Editor->WordWrap = true;
   // find end of headers
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      if (locked) LockWindowUpdate(0);
      MsgBoxHwnd(Application->MainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
        "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete msg;
      return NULL;
   }
   if (HasHeader("Fcc: ") && !ClearText)
   {
      ClearText = QSPoolNext();
      QSPoolAdd(msg,s(ClearText));
   }
   // massage required here because of encryption of headers
   MassageNewsgroupsAndReferencesAndSubject(msg);
   // cut-at-marks remove nulls and get body
   CutMessageAtCutmarks(msg);
   while (msg->Count && msg->Strings[msg->Count-1].Trim().IsEmpty())
      msg->Delete(msg->Count-1);
   TStringList *mail = new TStringList();
   int SendWrap = FinalFormat?0:SendWordWrap();
   while (msg->Count>idx+1)
   {
      AddString(msg->Strings[idx+1],mail,SendWrap); // wrap while adding
      msg->Delete(idx+1);
   }
   if (mail->Count)
   {
      if ((mrResult=PgpEncryptConventional(mail,passphrase))==mrOk)
      {
         msg->AddStrings(mail);
         Editor->Clear(); Editor->WordWrap = false;
         FinalFormat = true;

         AppProcessMessages(); Sleep(200);
         Editor->Lines->Text = msg->Text;
         Editor->SelStart = 0;
      }
   }
   else
   {
      if (locked) LockWindowUpdate(0); locked = false;
      MsgBoxHwnd(Handle,"Nothing to encrypt!","PGP Encrypt Error",MB_OK);
   }
   if (locked) LockWindowUpdate(0);
   Application->ProcessMessages();
   Sleep(200);
   delete mail;
   delete msg;

   PGPencBtn->Down = false;
   return mrResult==mrOk;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::ButtonsToPgpHeader(TStrings *Message)
{
   if (!Message->Count) return false;
   AnsiString pgp;
   if (PGPencBtn->Down && PGPsigBtn->Down) pgp = "encrypt;sign"; else
   if (PGPencBtn->Down) pgp = "encrypt"; else
   if (PGPsigBtn->Down) pgp = "sign";
   if (pgp.Length())
   {
      Message->Insert(0,PgpButtonsHdr+pgp);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::PgpHeaderToButtons(TStrings *Message)
{
   AnsiString pgp;
   THeaderManager *hm = new THeaderManager(Message);
   if (!(pgp=hm->GetDat(PgpButtonsHdr,Message)).IsEmpty())
   {
      PGPencBtn->Down = pgp.LowerCase().Pos("encrypt");
      PGPsigBtn->Down = pgp.LowerCase().Pos("sign");
      hm->Delete(PgpButtonsHdr);
      delete hm;
      return true;
   }
   delete hm;
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPencBtnClick(TObject *Sender)
{
   Editor->Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPsigBtnClick(TObject *Sender)
{
   Editor->Modified = true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::NeedsNymRecips() // not used
{
   if (PGPencBtn->Down) return true;
   if (PGPsigBtn->Down) return false;
   AnsiString encdat,keyid,dat,hdrdat=Headers->GetDat(PgpHdr);
   int i=0; while ((dat=GetToken(i++,hdrdat,";"))!="")
   {
      if ((encdat=GetToken(0,dat,";").Trim())!="" && encdat.Pos("encrypt")==1)
      {
         keyid = GetToken(1,encdat,"=");
         break;
      }
      encdat = "";
   }
   return !encdat.IsEmpty() && keyid.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopFinalFormatItemClick(TObject *Sender)
{
   bool special = false;
   if (HasNyms() && IsNymMessage() && NeedsNymRecips())
   {
      if (MsgBoxHwnd(Handle,
         s("In order to do final formatting on your NYM message, I'll need to\n")+
         s("get the recipient PGP keyid from you now.\n"),
         s("Confirm"),MB_OKCANCEL)==IDCANCEL) return;

      AnsiString sigdat,hdrdat,pgphdrdat;
      if (!PGPencBtn->Down)
      {
         if (!(hdrdat=Headers->GetDat(PgpHdr)).IsEmpty())
         {
            Headers->Delete(PgpHdr);
            int i=0; while ((sigdat=GetToken(i++,hdrdat,";").Trim())!="")
            {
               if (sigdat.Pos("sign")==1)
               {
                  pgphdrdat = sigdat+"; ";
                  break;
               }
            }
         }
      }
      else
      {
         if (PGPsigBtn->Down) pgphdrdat += "sign; ";
      }

      TStringList *recips = new TStringList();
      Headers->GetRecipients(recips);
      if (PgpGetEncryptList(AppMainForm,recips,false))
      {
         AppProcessMessages();
         if (recips->Count)
         {
            pgphdrdat += "encrypt=";
            for (int i=0; i<recips->Count; i++)
            {
               pgphdrdat += recips->Strings[i].SubString(1,10);
               if (i<recips->Count-1) pgphdrdat += ",";
            }
         }
      }
      if ((special=!pgphdrdat.IsEmpty())==true)
      {
         Editor->Lines->Insert(0,PgpHdr+pgphdrdat);
         PGPsigBtn->Down = false;
         PGPencBtn->Down = false;
      }
      delete recips;
   }
   if (special || MsgBoxHwnd(Handle,"Format Message?","Confirm",MB_OKCANCEL)==IDOK)
   {
      if (HasNyms() && IsNymMessage()) HandleNym();
      SetRedraw(this,0);
      Editor->WordWrap = false;
      WrapMessage(Editor->Lines,SendWordWrap());
      Editor->SelStart = 0;
      FinalFormat = true;
      SetRedraw(this,1);
   }
   SetRedraw(this,1);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupMenuClick(TObject *Sender)
{
   TTextWin::PopupMenuClick(Sender);
   if (HasPgp())
      PopDoPgpItem->Enabled = PGPencBtn->Down || PGPsigBtn->Down || Headers->Has(PgpHdr);
   else PopDoPgpItem->Enabled = PGPencBtn->Down;
   if (ClearText) PopUndoPgpItem->Enabled = true;

   bool editwrapwin = GetAppIni("WordWrap","").ToIntDef(1);
   bool sendwrapwin = GetAppIni(SendWrapWin,"").ToIntDef(1);
   bool sendwrapnot = GetAppIni(SendWrapNot,"").ToIntDef(0);
   PopFinalFormatItem->Enabled = !FinalFormat &&
      !(editwrapwin && sendwrapwin) && !(!editwrapwin && sendwrapnot);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopDoPgpItemClick(TObject *Sender)
{
   if (HasPgp()) HandlePGP();
   else HandleCPGP();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveBtnClick(TObject *Sender)
{
   TPoint cpoint,poppoint={ -2,27 };
   cpoint = OkBtn->ClientToScreen(poppoint);
   PopupSaveMenu->Popup(cpoint.x,cpoint.y);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveMenuPopup(TObject *Sender)
{
   PopupSaveItem->Enabled = Editor->Modified;
   PopupDeleteItem->Enabled = true;
   if (Type==tNewMessage||Type==tNewArticle) PopupTransferItem->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveItemClick(TObject *Sender)
{
   Save();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupQueueMessageClick(TObject *Sender)
{
   Queue(true);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveasItemClick(TObject *Sender)
{
   SaveAs();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveasTemplateItemClick(TObject *Sender)
{
   SaveAsTemplate();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveDefMessageItemClick(TObject *Sender)
{
   SaveDefMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveDefArticleItemClick(TObject *Sender)
{
   SaveDefArticle();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::TransferMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   switch(Type)
   {
      case tMessage:
      case tArticle: break;
      default: IndexStr=Headers->IndexString(Editor->Lines,' ');
   }
   AnsiString NewDataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   TStringList *tmp = new TStringList();
   tmp->Text = Editor->Lines->Text;
   ButtonsToPgpHeader(tmp);
   PutAppData(NewDataKey,Editor->Lines);
   PutAppData(DataKey,NULL);
   DataKey = NewDataKey;
   delete tmp;

   Mailbox = Boxname;
   Type = tMessage;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CopyMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   switch(Type)
   {
      case tMessage:
      case tArticle: break;
      case tNewMessage:
      case tNewArticle: IndexStr=Headers->IndexStringNew(Editor->Lines); break;
      default: IndexStr=Headers->IndexString(Editor->Lines,' ');
   }
   DataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   TStringList *tmp = new TStringList();
   tmp->Text = Editor->Lines->Text;
   ButtonsToPgpHeader(tmp);
   PutAppData(DataKey,tmp);
   delete tmp;

   Mailbox = Boxname;
   Type = tMessage;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupTransferItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox = GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   TransferMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Oldbox);
   if (mbw!=NULL) mbw->RefreshIndex();
   mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupCopyMessageItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox=GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   CopyMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupDeleteItemClick(TObject *Sender)
{
   AnsiString doc;
//tNewMessage,tMessage,tNewArticle,tArticle,tNewNote,tNote,tDraft,tTemplate
   if (Type==tNewMessage||Type==tNewArticle||DataKey.IsEmpty())
   {
      switch (Type)
      {
         case tNewArticle: doc="article"; break;
         default: doc="message";
      }
      if (MsgBox("Delete this "+doc+" from the system?","Confirm",MB_OKCANCEL)==IDOK)
      {
         Editor->Modified = false;
         Close();
      }
      return;
   }
   switch (Type)
   {
      case tDraft: doc="draft"; break;
      case tArticle: doc="article"; break;
      case tTemplate: doc="template"; break;
      default: doc="message";
   }
   if (MsgBox("Delete this "+doc+" from the system?","Confirm",MB_OKCANCEL)==IDOK)
   {
      Editor->Clear(); Caption=" deleting "+doc+"..."; Sleep(500);
      Application->ProcessMessages();
      PutAppData(DataKey,NULL);
      if (Type==tMessage||Type==tArticle)
      {
         TMailboxWin *mbw=FindOpenMailbox(Mailbox);
         if (mbw!=NULL) mbw->RefreshIndex();
      }
      Editor->Modified = false;
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveMessageBtnClick(TObject *Sender)
{
//   if (Save()) SaveMessageBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::EditorSelectionChange(TObject *Sender)
{
   TTextWin::EditorSelectionChange(Sender);
   if (Editor->Modified) TrashBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnEnter(TObject *Sender)
{
   if (!SaveBtn->HasMouse()) SaveBtn->Perform(CM_MOUSEENTER,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnExit(TObject *Sender)
{
   if (SaveBtn->HasMouse()) SaveBtn->Perform(CM_MOUSELEAVE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveBtnEnter(TObject *Sender)
{
   if (!OkBtn->HasMouse()) OkBtn->Perform(CM_MOUSEENTER,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveBtnExit(TObject *Sender)
{
   if (OkBtn->HasMouse()) OkBtn->Perform(CM_MOUSELEAVE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::AddrsBtnClick(TObject *Sender)
{
   AppMainForm->Perform(WM_OPENADDRESSES,0,0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::MsgHelpBtnClick(TObject *Sender)
{
   AnsiString sections = "NewMessage\nMixmasterChains";
   if (HasPgp()) sections += "\nNewMessagePgp\nTemplates\nPgpPassphrase";
   if (HasNyms()) sections += "\nNewMessageNym";
   OpenHelp(sections,"New Messages","Introduction",Application->MainForm);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopUndoPgpItemClick(TObject *Sender)
{
   /*if (MsgBoxHwnd(Handle,"Restore message to clear text?","Confirm",MB_OKCANCEL)==IDNO)
      return;
   Editor->Lines->Clear(); AppProcessMessages(); Sleep(100);
   bool locked = LockWindowUpdate(Handle);
   //if (ClearText) QSPoolGet(Editor->Lines,s(ClearText));
   PopUndoPgpItem->Enabled = false;
   PopDoPgpItem->Enabled = true;
   Editor->SelStart = 0;
   AppProcessMessages();
   if (locked) LockWindowUpdate(0);
   ClearText = 0;*/
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::UseLibBtnClick(TObject *Sender)
{
   SaveUsenetArticle(Editor,this);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAsNote()
{
   AnsiString Cap,path = GetSaveMessagePathEx(UserNotes,Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      Cap = Caption;
      Caption = "Saving...";
      AppProcessMessages(); Sleep(200);
      TStringList *lines = new TStringList();
      GetUnWrappedText(lines);
      PutAppData(DataKey,lines);
      Editor->Clear(); AppProcessMessages(); Sleep(200);
      path = GetParam(0,UserNotes+": "+GetParam(1,DataKey,PS.c_str()));
      NoteWin = new TNoteWin(Left,Top,Width,Height,path,lines,AppMainForm);
      Editor->Modified = false;
      Close();
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveasNote1Click(TObject *Sender)
{
   SaveAsNote();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::TrashBtnClick(TObject *Sender)
{
   AnsiString delmsg;
   switch (Type)
   {
      case tNewMessage:
      case tNewArticle:
         if (MsgBoxHwnd(Handle,
           "Close this message without saving?","Confirm",MB_OKCANCEL)==IDOK)
         {
            Editor->Modified = false;
            Close();
         }
         break;
      case tTemplate: delmsg = "template"; break;
      case tMessage: delmsg = "message"; break;
      case tArticle: delmsg = "article"; break;
      case tDraft: delmsg = "draft"; break;
   }

   if (!delmsg.IsEmpty() && MsgBoxHwnd(Handle,
     "Delete this "+delmsg+" from the system?","Confirm",MB_OKCANCEL)==IDOK)
   {
      Caption=" Deleting..."; Sleep(100);
      Application->ProcessMessages();
      PutAppData(DataKey,NULL);
      // check for this index open on workspace
      TMailboxWin *mbw=FindOpenMailbox(Mailbox);
      if (mbw!=NULL) mbw->RefreshIndex();
      Editor->Modified = false;
      Close();
   }
}
//---------------------------------------------------------------------------
